<?php
 /*
  * Copyright (C) 2006 paydesign_cc INC.
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
  * the Free Software Foundation; either version 2 of the License, or
  * (at your option) any later version.
  *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU General Public License
  * along with Shigeo; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  *
  * $Id$
  */
class paydesign_admin extends base {
  function paydesign_admin() {
    self::paydesign_update_status();
  }

  function paydesign_save_status($orders_id, $status_id, $comments, $notify=0) {
    global $db;

    $sql_data_array = array(
      'orders_id'        =>$orders_id, // 注文ID
      'orders_status_id' =>$status_id, // ステータス
      'date_added'       =>'now()',    // ヒストリー追加日時
      'customer_notified'=>$notify,    // 通知なし
      'comments'         =>$comments,  // コメント
    );
    zen_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);
  }

  // 決済ステータス変更処理
  function paydesign_update_status() {
    // 無関係な処理を飛ばす
    if (strpos($_SERVER['PHP_SELF'], '/orders.php') === false)
      return;

    if ($_REQUEST['action'] != 'update_order')
      return;

    // 存在チェック
    $oID = (int)$_REQUEST['oID'];
    if (!self::paydesign_is_order_exist($oID))
      return;

    // クレジットカード決済
    $cc_code = "";
    if (MODULE_PAYMENT_PAYDESIGN_CC_STATUS == 'True') {
      require_once '../'.DIR_WS_MODULES.'payment/paydesign_cc.php';
      $obj     = new paydesign_cc();
      $cc_code = $obj->code;
    }

    $cv_code = "";
    // コンビニ決済
    if (MODULE_PAYMENT_PAYDESIGN_CV_STATUS == 'True') {
      require_once '../'.DIR_WS_MODULES.'payment/paydesign_cv.php';
      $obj     = new paydesign_cv();
      $cv_code = $obj->code;
    }

    // 決済方法チェック
    $payment_module = self::paydesign_get_payment_module_code($oID);
    if ($payment_module == $cc_code)
      self::paydesign_cc_update_status($oID);
    else if ($payment_module == $cv_code)
      self::paydesign_cv_update_status($oID);
  }

  // クレジットカードステータス変更
  function paydesign_cc_update_status($oID) {
    global $messageStack;

    $cur_status = (int)self::paydesign_get_orders_status($oID);
    $new_status = (int)$_REQUEST['status'];

    // ステータス変更なければ、無処理
    if ($cur_status == $new_status)
      return;
    // 確定
    else if ($new_status == MODULE_PAYMENT_PAYDESIGN_CC_SENDED_STATUS_ID) {
      // 与信のみの場合のみ処理？
      if (!self::paydesign_get_authorize_only($oID))
        return;

      // 決済確定送信
      $sid = self::paydesign_get_sid($oID);
      $url = MODULE_PAYMENT_PAYDESIGN_CC_CONFIRM_URL
           . '?IP='.MODULE_PAYMENT_PAYDESIGN_CC_IP
           . '&SID='.$sid;
      $res = file_get_contents($url);
      self::paydesign_save_status($oID, $cur_status, $res, -1);

      // 処理確認（失敗時はメール送信）
      // 成功
      if (strpos($res, "C-CHECK:OK") !== false)
        ;
      else {
        $date_purchased = date('Y年m月d日 H時i分', strtotime(self::paydesign_get_date_purchased($oID)));
        $order_url      = zen_href_link(FILENAME_ORDERS, 'oID='.$oID.'&action=edit', 'NONSSL');
        require_once DIR_WS_LANGUAGES.$_SESSION['language'].'/modules/payment/paydesign_cc.php';
        $body = MODULE_PAYMENT_PAYDESIGN_CC_MAIL_DETERMINE_FAILED_BODY;
        $body = str_replace('[ADMIN_NAME]',     STORE_OWNER,     $body);
        $body = str_replace('[ORDER_ID]',       $oID,            $body);
        $body = str_replace('[DATE_PURCHASED]', $date_purchased, $body);
        $body = str_replace('[ORDER_URL]',      $order_url,      $body);

        zen_mail(
          STORE_OWNER_EMAIL_ADDRESS,
          STORE_OWNER_EMAIL_ADDRESS,
          MODULE_PAYMENT_PAYDESIGN_CC_MAIL_DETERMINE_FAILED_SUBJECT,
          $body,
          STORE_NAME,
          EMAIL_FROM,
          array());

        $messageStack->add_session(MODULE_PAYMENT_PAYDESIGN_CC_MAIL_DETERMINE_FAILED_MESSAGE, 'caution');

        // 元に戻す(今は戻さない)
        // $_GET['status']  = $cur_status;
        // $_POST['status'] = $cur_status;
      }
    }

    // 取消
    else if ($new_status == MODULE_PAYMENT_PAYDESIGN_CC_CANCEL_STATUS_ID) {
      // 与信の場合
      if (self::paydesign_get_authorize_only($oID)) {
        // 配送済みの場合は返品
        if (self::paydesign_has_orders_delived($oID))
          $url = MODULE_PAYMENT_PAYDESIGN_CC_CAN_RCPT_URL;
        else
          $url = MODULE_PAYMENT_PAYDESIGN_CC_CAN_AUTH_URL;
      }
      else
        $url = MODULE_PAYMENT_PAYDESIGN_CC_CAN_RCPT_URL;

      // 決済取消送信
      $sid = self::paydesign_get_sid($oID);
      $url .= '?IP='.MODULE_PAYMENT_PAYDESIGN_CC_IP
           .  '&PASS='.MODULE_PAYMENT_PAYDESIGN_CC_PASSWORD
           .  '&SID='.$sid;
      $res = file_get_contents($url);
      self::paydesign_save_status($oID, $cur_status, $res, -1);

      // 処理確認（失敗時はメール送信）
      // 成功
      if (strpos($res, "C-CHECK:OK") !== false)
        ;
      else {
        $date_purchased = date('Y年m月d日 H時i分', strtotime(self::paydesign_get_date_purchased($oID)));
        $order_url      = zen_href_link(FILENAME_ORDERS, 'oID='.$oID.'&action=edit', 'NONSSL');
        require_once DIR_WS_LANGUAGES.$_SESSION['language'].'/modules/payment/paydesign_cc.php';
        $body = MODULE_PAYMENT_PAYDESIGN_CC_MAIL_CANCEL_FAILED_BODY;
        $body = str_replace('[ADMIN_NAME]',     STORE_OWNER,     $body);
        $body = str_replace('[ORDER_ID]',       $oID,            $body);
        $body = str_replace('[DATE_PURCHASED]', $date_purchased, $body);
        $body = str_replace('[ORDER_URL]',      $order_url,      $body);

        zen_mail(
          STORE_OWNER_EMAIL_ADDRESS,
          STORE_OWNER_EMAIL_ADDRESS,
          MODULE_PAYMENT_PAYDESIGN_CC_MAIL_CANCEL_FAILED_SUBJECT,
          $body,
          STORE_NAME,
          EMAIL_FROM,
          array());

        $messageStack->add_session(MODULE_PAYMENT_PAYDESIGN_CC_MAIL_CANCEL_FAILED_MESSAGE, 'caution');

        // 元に戻す(今は戻さない)
        // $_GET['status']  = $cur_status;
        // $_POST['status'] = $cur_status;
      }
    }
  }

  // コンビニステータス変更
  function paydesign_cv_update_status($oID) {
    global $messageStack;

    $cur_status = (int)self::paydesign_get_orders_status($oID);
    $new_status = (int)$_REQUEST['status'];

    // ステータス変更なければ、無処理
    if ($cur_status == $new_status)
      return;

    // 取消
    if ($new_status == MODULE_PAYMENT_PAYDESIGN_CV_CANCEL_PAYMENT_STATUS_ID) {
      $url = MODULE_PAYMENT_PAYDESIGN_CV_CANCEL_URL;

      // 決済取消送信(入金待ちの時のみ)
      if ($cur_status == MODULE_PAYMENT_PAYDESIGN_CV_ORDER_STATUS_ID) {
        $sid = self::paydesign_get_sid($oID);
        $url .= '?IP='.MODULE_PAYMENT_PAYDESIGN_CV_IP
             .  '&SID='.$sid;
        $res = file_get_contents($url);
        self::paydesign_save_status($oID, $cur_status, $res, -1);

        // 処理確認（失敗時はメール送信）
        // 成功
        if (strpos($res, "C-CHECK:OK") !== false)
          ;
        else {
          $date_purchased = date('Y年m月d日 H時i分', strtotime(self::paydesign_get_date_purchased($oID)));
          $order_url      = zen_href_link(FILENAME_ORDERS, 'oID='.$oID.'&action=edit', 'NONSSL');
          require_once DIR_WS_LANGUAGES.$_SESSION['language'].'/modules/payment/paydesign_cv.php';
          $body = MODULE_PAYMENT_PAYDESIGN_CV_MAIL_CANCEL_FAILED_BODY;
          $body = str_replace('[ADMIN_NAME]',     STORE_OWNER,     $body);
          $body = str_replace('[ORDER_ID]',       $oID,            $body);
          $body = str_replace('[DATE_PURCHASED]', $date_purchased, $body);
          $body = str_replace('[ORDER_URL]',      $order_url,      $body);

          zen_mail(
            STORE_OWNER_EMAIL_ADDRESS,
            STORE_OWNER_EMAIL_ADDRESS,
            MODULE_PAYMENT_PAYDESIGN_CV_MAIL_CANCEL_FAILED_SUBJECT,
            $body,
            STORE_NAME,
            EMAIL_FROM,
            array());

          $messageStack->add_session(MODULE_PAYMENT_PAYDESIGN_CV_MAIL_CANCEL_FAILED_MESSAGE, 'caution');

          // 元に戻す(今は戻さない)
          // $_GET['status']  = $cur_status;
          // $_POST['status'] = $cur_status;
        }
      }
    }
  }

  // 注文存在確認
  function paydesign_is_order_exist($oID) {
    global $db;
    $result = $db->Execute("select orders_id from " . TABLE_ORDERS . " where orders_id=".(int)$oID);
    if ($result->EOF)
      return false;
    else
      return true;
  }

  // 決済方法取得
  function paydesign_get_payment_module_code($oID) {
    global $db;
    $result = $db->Execute("select payment_module_code from " . TABLE_ORDERS . " where orders_id=".(int)$oID);
    return $result->fields['payment_module_code'];
  }

  // ステータス取得
  function paydesign_get_orders_status($oID) {
    global $db;
    $result = $db->Execute("select orders_status from " . TABLE_ORDERS . " where orders_id=".(int)$oID);
    return $result->fields['orders_status'];
  }

  // 配送済み確認
  function paydesign_has_orders_delived($oID) {
    global $db;
    $result = $db->Execute("select orders_status_id from " . TABLE_ORDERS_STATUS_HISTORY . " where orders_id=".(int)$oID." and orders_status_id=".(int)MODULE_PAYMENT_PAYDESIGN_CC_SENDED_STATUS_ID);
    return !$result->EOF;
  }

  // 与信取得
  function paydesign_get_authorize_only($oID) {
    global $db;
    $result = $db->Execute("select authorize_only from " . TABLE_PAYDESIGN_TRANSACTIONS . " where orders_id=".(int)$oID);
    return $result->fields['authorize_only'];
  }

  // sid取得
  function paydesign_get_sid($oID) {
    global $db;
    $result = $db->Execute("select sids from " . TABLE_PAYDESIGN_TRANSACTIONS . " where orders_id=".(int)$oID);
    return $result->fields['sids'];
  }

  // purchase_data取得
  function paydesign_get_date_purchased($oID) {
    global $db;
    $result = $db->Execute("select date_purchased from " . TABLE_ORDERS . " where orders_id=".(int)$oID);
    return $result->fields['date_purchased'];
  }
}
