<?php
/**
 * functions_paydesign.php
 *
 * @package functions
 * @copyright Copyright 2003-2005 Zen Cart Development Team
 * @copyright Portions Copyright 2003 osCommerce
 * @license http://www.zen-cart.com/license/2_0.txt GNU Public License V2.0
 * @version $Id: functions_paydesign.php 2774 2006-01-03 03:07:08Z ajeh $
 */


// レコード取得
function paydesign_get_record($sid, $fuka="", $type="") {
  global $db;
  $sql = "select
            *
          from ".
            TABLE_PAYDESIGN_TRANSACTIONS."
          where
            sids='".(int)$sid."'";
  if ($fuka != "")
    $sql .= " and fuka='".zen_db_input($fuka)."'";
  if ($type != "")
    $sql .= " and type='".zen_db_input($type)."'";
  return $db->Execute($sql);
}

// sidとfuka情報による存在チェック
// おもにペイデザインからの呼び出し時に使用する
function paydesign_is_exist($sid, $fuka, $type="") {
  $result = paydesign_get_record($sid, $fuka, $type);
  if ($result->EOF)
    return false;
  else
    return true;
}

function paydesign_get_session($sid, $fuka, $type="") {
  $result = paydesign_get_record($sid, $fuka, $type);
  if ($result->EOF)
    return null;
  else
    return $result->fields['session_value'];
}

function paydesign_get_response($sid, $fuka, $type="") {
  $result = paydesign_get_record($sid, $fuka, $type);
  if ($result->EOF)
    return null;
  else
    return $result->fields['response'];
}

// sidによる注文ID取得
function paydesign_get_orders_id($sid) {
  $result = paydesign_get_record($sid);
  if ($result->EOF)
    return false;
  else
    return $result->fields['orders_id'];
}

// sidの新規取得
function paydesign_get_new_sid() {
  global $db;

  // 過去の不必要なsidの削除
  $today = time()-86400;
  $today = date('Y-m-d H:i:s', $today);
  $sql   = "delete
            from ".
              TABLE_PAYDESIGN_TRANSACTIONS."
            where
              orders_id=0
              and created_at<='".$today."'";
  $db->Execute($sql);

  // sidは毎回作成する
  // sidと金額をペイデザイン側でつなげているようで
  // 一度リクエストを出してしまうと金額を変更できない
  // 無駄なデータが生成されてしまうがしょうがないかな？

  // SIDの取得
  $sql_data_array = array(
    'created_at'=>'now()'
  );
  zen_db_perform(TABLE_PAYDESIGN_TRANSACTIONS, $sql_data_array);
  return $db->Insert_ID();
}

// fuka情報の取得
function paydesign_get_fuka() {
  return md5(uniqid(rand(), true));
}

// 要求レコードの保存
function paydesign_save_request_parm($sid, $type, $request, $fuka, $session="") {
  global $db;

  if (MODULE_PAYMENT_PAYDESIGN_CC_IS_AUTHORIZE_ONLY == 'True')
    $authorize_only = 1;
  else
    $authorize_only = 0;

  $sql_data_array = array(
    'customers_id'   => $_SESSION['customer_id'], // 顧客ID
    'type'           => $type,                    // 決済方法
    'status'         => 'wait',                   // 処理待ち
    'request'        => $request,                 // リクエスト
    'fuka'           => $fuka,                    // 付加情報
    'authorize_only' => $authorize_only,          // 与信のみ
  );
  if ($session != "") {
    $sql_data_array['session_value'] = $session;
  }
  zen_db_perform(TABLE_PAYDESIGN_TRANSACTIONS, $sql_data_array, "update", "sids=".(int)$sid);
}

// 注文IDの更新
function paydesign_save_orders_id($sid, $orders_id) {
  global $db;

  $sql_data_array = array(
    'orders_id' =>$orders_id, // 注文ID
  );
  zen_db_perform(TABLE_PAYDESIGN_TRANSACTIONS, $sql_data_array, "update", "sids=".(int)$sid);
}

// 返信レコードの保存
function paydesign_save_response_parm($sid, $status, $response, $seq, $datetime) {
  global $db;

  $sql_data_array = array(
    'status'           =>$status,   // 成功
    'response'         =>$response, // 通知情報
    'finish_payment_id'=>$seq,      // SID
    'finish_payment_at'=>$datetime  // 決済完了日時
  );
  zen_db_perform(TABLE_PAYDESIGN_TRANSACTIONS, $sql_data_array, "update", "sids=".(int)$sid);
}

// 注文ステータス更新
function paydesign_save_status($sid, $status_id, $comments, $notify=0) {
  global $db;

  $orders_id = paydesign_get_orders_id($sid);
  $sql_data_array = array(
    'orders_id'        =>$orders_id, // 注文ID
    'orders_status_id' =>$status_id, // ステータス
    'date_added'       =>'now()',    // ヒストリー追加日時
    'customer_notified'=>$notify,    // 通知なし
    'comments'         =>$comments,  // コメント
  );
  zen_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);

  $sql_data_array = array(
    'orders_status' =>$status_id,     // ステータス
  );
  zen_db_perform(TABLE_ORDERS, $sql_data_array, "update", "orders_id=".$orders_id);
}

// 注文ステータス更新
function paydesign_http_build_query($param) {
  $ret = "";
  foreach ($param as $key=>$value) {
    if ($ret != "")
      $ret .= '&';
    $ret .= $key."=".htmlspecialchars($value);
  }
  return $ret;
}

// 氏名変換
function paydesign_name_convert($name) {
  return mb_convert_kana($name, "RNASKHV");
}

// カナ変換
function paydesign_kana_convert($kana) {
  $check = "アイウエオカキクケコサシスセソタチツテトナニヌネノハヒフヘホマミムメモヤユヨラリルレロワヲンガギグゲゴザジズゼゾダヂヅデドパピプペポバビブベボッァィゥェォャュョヮー";
  $ret   = "";
  $kana  = mb_convert_kana($kana, "CKV");
  for ($i=0; $i<mb_strlen($kana); $i++) {
    if (mb_strpos($check, mb_substr($kana, $i, 1)) !== false)
      $ret .= mb_substr($kana, $i, 1);
  }
  return $ret;
}

// 郵便番号変換
function paydesign_zip_convert($tel) {
  $ret = "";
  $tel = mb_convert_kana($tel, "n"); // 全角数字->半角数字
  for ($i=0; $i<strlen($tel); $i++) {
    $c = substr($tel, $i, 1);
    if ($c>="0" && $c<="9")
      $ret .= $c;
  }
  if (strlen($ret)==7) {
    return substr($ret, 0, 3);
  } else {
    return substr($ret, 0, 7);
  }
}

function paydesign_zip_convert2($tel) {
  $ret = "";
  $tel = mb_convert_kana($tel, "n"); // 全角数字->半角数字
  for ($i=0; $i<strlen($tel); $i++) {
    $c = substr($tel, $i, 1);
    if ($c>="0" && $c<="9")
      $ret .= $c;
  }
  if (strlen($ret)==7) {
    return substr($ret, 3, 4);
  } else {
    return "";
  }
}

// 電話番号変換
function paydesign_tel_convert($tel) {
  $ret = "";
  $tel = mb_convert_kana($tel, "n"); // 全角数字->半角数字
  for ($i=0; $i<strlen($tel); $i++) {
    $c = substr($tel, $i, 1);
    if ($c>="0" && $c<="9")
      $ret .= $c;
  }
  return $ret;
}

// 状態取得
function paydesign_get_status($sid, $fuka, $type="") {
  $result = paydesign_get_record($sid, $fuka, $type);
  if ($result->EOF)
    return null;
  else
    return $result->fields['status'];
}

// 顧客ID取得
function paydesign_get_customers_id($sid, $fuka, $type="") {
  $result = paydesign_get_record($sid, $fuka, $type);
  if ($result->EOF)
    return null;
  else
    return $result->fields['customers_id'];
}

// CCユーザーID取得
function paydesign_get_cc_user_id($customers_id) {
  global $db;
  $sql    = "select customers_paydesign_cc_userid from ".TABLE_CUSTOMERS." where customers_id=".(int)$customers_id;
  $result = $db->Execute($sql);
  if ($result->EOF)
    return null;
  else
    return $result->fields['customers_paydesign_cc_userid'];
}

// CCユーザーID保存
function paydesign_save_cc_user_id($customers_id, $cc_userid) {
  global $db;
  $sql    = "update ".TABLE_CUSTOMERS." set customers_paydesign_cc_userid='".zen_db_input($cc_userid)."' where customers_id=".(int)$customers_id;
  $result = $db->Execute($sql);
}

// CCユーザーID消去
function paydesign_erase_cc_user_id($customers_id) {
  global $db;
  $sql    = "update ".TABLE_CUSTOMERS." set customers_paydesign_cc_userid='' where customers_id=".(int)$customers_id;
  $result = $db->Execute($sql);
}

// CC SCODE取得
function paydesign_get_cc_scode($customers_id) {
  global $db;
  $sql    = "select customers_paydesign_cc_scode from ".TABLE_CUSTOMERS." where customers_id=".(int)$customers_id;
  $result = $db->Execute($sql);
  if ($result->EOF)
    return null;
  else
    return $result->fields['customers_paydesign_cc_scode'];
}

// CC SCODE保存
function paydesign_save_cc_scode($customers_id, $cc_scode) {
  global $db;
  $sql    = "update ".TABLE_CUSTOMERS." set customers_paydesign_cc_scode='".zen_db_input($cc_scode)."' where customers_id=".(int)$customers_id;
  $result = $db->Execute($sql);
}
